<script>
	import SVG from "@/components/svg.svelte"

	import { isLight } from "@/stores/static"
	import { tick } from "svelte"
	import { page } from "$app/stores"
	import { l, t } from "@/i18n"
	import { isPhone } from "@/stores/responsiveness"
	import { writable } from "svelte/store"
	import { serializeSchema } from "@/helpers/schema"

	const crumbs = writable(null)

	const generateCrumbs = async () => {
		crumbs.set(null)
		await tick()
		let result = [ { text: "default.crumbs.homepage", i18n: true, icon: "garage", url: "" } ]

		if ($page.data.crumbs) result.push(...$page.data.crumbs)

		crumbs.set(result)
	}
	$: if ($page.data.crumbs) generateCrumbs()

	const lastCrumb = i => i + 1 == $crumbs.length

	$: secondItem = $crumbs?.[$crumbs?.length - 2]

	$: schema = (() => {
		let items = []

		for (let i in $crumbs) {
			let crumb = $crumbs[i]
			
			let data = {
				"@type": "ListItem",
				"position": parseInt(i)+1,
				"name": $t(crumb.text)
			}

			if (!lastCrumb(parseInt(i))) data.item = "https://dcr.ae" + $l(crumb.url)

			items.push(data)
		}

		return {
			"@context": "https://schema.org",
			"@type": "BreadcrumbList",
			"itemListElement": items
		}
	})()

</script>

<svelte:head>
	{@html serializeSchema(schema)}
</svelte:head>

<template lang="pug">
.breadcrumbs.is-flex.is-align-items-center.is-justify-content-flex-start( class:dark='{!$isLight}' )
	+if('$crumbs && $crumbs.length')
		+if('$isPhone && secondItem')
			a.crumb.is-flex.is-aign-items-center.is-justify-content-flex-start( href!='{$l(secondItem.url)}' )
				span.icon.is-flex.is-align-items-center: SVG( folder="icons" name="angle-left" )
				span.text {secondItem.i18n ? $t(secondItem.text) : secondItem.text}
		+if('!$isPhone')
			+each('$crumbs as crumb, i')
				svelte:element.crumb.is-flex.is-aign-items-center.is-justify-content-flex-start(
						this!='{$l(crumb.url) && !lastCrumb(i) ? "a" : "div"}'
						href!='{$l(crumb.url)}')
					+if('crumb.icon')
						span.icon.is-flex.is-align-items-center: SVG( folder="icons" name!='{crumb.icon}' )
					span.text {crumb.i18n ? $t(crumb.text) : crumb.text}
				+if('!lastCrumb(i)')
					.angle.icon.is-flex.is-align-items-center: SVG( folder="icons" name="angle-right" )
</template>

<style lang="scss">
.breadcrumbs {
	margin-top: 1rem;
	margin-bottom: 3rem;

	&.dark {
		a {
			.icon {
				:global(svg path) {
					fill: #79CFFF;
				}
			}
			.text {
				color: #79CFFF;
			}
		}
		div {
			.text {
				color: #D8D8D8;
			}
		}
	}
}

.crumb {
	cursor: default;
	user-select: none;
	.icon {
		width: 1rem;
		margin-right: .375rem;
		:global(svg) {
			height: 1rem;
		}
		:global(svg path) {
			fill: $gray-text;
			transition: fill .2s ease-in-out;
		}
	}
	.text {
		font-size: .875rem;
		font-weight: 300;
		color: $gray-text;
		transition: color .2s ease-in-out;
	}
}

a.crumb {
	cursor: pointer;
	.icon {
		:global(svg path) {
			fill: $blue-link;
		}
	}
	.text {
		color: $blue-link;
		text-decoration: underline;
		text-decoration-color: transparent;
		transition: text-decoration-color .2s ease-in-out;
	}
	&:hover {
		.text {
			text-decoration-color: $blue-link;
		}
	}
}

.angle {
	margin: 0 .5rem 0 .375rem;
	width: .5rem;
	:global(svg) {
		height: .5rem;
	}
	:global(svg path) {
		fill: $gray-text;
	}
}
</style>